#include <iostream>
#include <vector>
#include <string>
#include <set>

using namespace std;

int add(int a, int b, int m) {
	return ((int64_t)a + b) % m;
}

int sub(int a, int b, int m) {
	return ((int64_t)m + a - b) % m;
}

int mul(int a, int b, int m) {
	return ((int64_t)a * b) % m;
}

int val(char c) {
	return (int)(c - 'a' + 1);
}

int hash_string(string s) {
	int p = 31, M = 1000000009;
	int hash = 0;

	for(int i = 0; i < s.size(); i++)
		hash = add(mul(hash, p, M), val(s[i]), M);

	return hash;
}

int main() {
	int p = 31, M = 1000000009;

	string s;
	int k;
	
	cin >> k >> s;

	set<int> h;
	int sh = hash_string(s.substr(0, k));
	h.insert(sh);

	int pn = 1;
	for(int i = 0; i < k; i++)
		pn = mul(pn, p, M);

	for(int i = k; i < s.size(); i++) {
		sh = mul(sh, p, M);
		sh = sub(sh, mul(pn, val(s[i - k]), M), M);
		sh = add(sh, val(s[i]), M);

		if(h.find(sh) != h.end()) {
			cout << s.substr(i - k + 1, k) << '\n';
			break;
		}
		h.insert(sh);
	}

	return 0;
}
